// Make a namespace.
if (typeof WABlank == 'undefined') {
  var WABlank = {};
}

/**
 * UI controller that is loaded into the main player window
 */
WABlank.Controller = {

	TAB_STATE_PREF: 'songbird.browser.tab_state',
	TAB_STATE_PREV_PREF: 'extensions.wa-blank.tab_state',
	JSON: Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON),

  /**
   * Called when the window finishes loading
   */
  onLoad: function() {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
	  .getService(Components.interfaces.nsIPrefService);
		var branch = prefService.getBranch(this.TAB_STATE_PREF);
		branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
    var me = this;
		var listener = {
		  observe : function(aSubject, aTopic, aData) {
			  if (aTopic == 'nsPref:changed') {
			  	branch.removeObserver("", listener, false);
					var tabState = Application.prefs.getValue(me.TAB_STATE_PREF, null);
					var tabObject = null;
					try {
						if (tabState) tabObject = me.JSON.decode(tabState);
					} catch(e) {
						me.log(e.toString());
						tabObject = null;
					}
					
					var tabs = null;
					if (tabObject && "urlList" in tabObject) {
    			  tabs = tabObject.urlList;
    			}

    			if (!tabs || tabs.length == 0 || !tabs[0].listGUID) { //invalid tab state
    				//restore previous state
    				me.log("Invalid tab state: " + tabState);
    				try {
							var prevState = Application.prefs.getValue(me.TAB_STATE_PREV_PREF, null);
	    				if (prevState) {
		    				me.log("Restore prev media tab state: "+prevState);
	    					var mediaTab = me.JSON.decode(prevState);
	    					if (tabs) {
	    						tabObject.urlList.unshift(mediaTab);
	    					} else {
	    						tabObject.urlList = [mediaTab];
	    					}
	    					Application.prefs.setValue(me.TAB_STATE_PREF, me.JSON.encode(tabObject));
	    				}
    				} catch(e) {
    					me.log(e.toString());
    				}
    			} else {
    				try {
	    				Application.prefs.setValue(me.TAB_STATE_PREV_PREF, me.JSON.encode(tabs[0]));
    				} catch(e) {
    					me.log(e.toString());
    				}
    			}
    			
    			branch.addObserver("", listener, false);
			  }
			}
		};
    try {
			branch.addObserver("", listener, false);
		} catch(e) {
			me.log(e.toString());
		}
  },
  
  log: function(str) {
		var consoleService = Cc['@mozilla.org/consoleservice;1']
									.getService(Ci.nsIConsoleService);
		consoleService.logStringMessage("[WAB] " + (str ? str.toString() : "null"));
  }
};

window.addEventListener("load", function(e) { WABlank.Controller.onLoad(e); }, false);
